Skip to content

Load data from a REST API

This tutorial shows how to fetch JSON from a REST API and populate Handsontable after initialization. It starts the grid with data: [], shows a loading message, then displays success or error feedback in the UI.

JavaScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
registerAllModules();
const STATUS_LOADING = 'Loading users...';
const STATUS_READY = 'Loaded users from REST API.';
const STATUS_ERROR = 'Failed to load users. Try again.';
const container = document.querySelector('#example1');
if (!container) {
throw new Error('Missing #example1 element.');
}
const controlsContainer = document.createElement('div');
const controls = document.createElement('div');
const statusOutput = document.createElement('output');
const retryButton = document.createElement('button');
const gridContainer = document.createElement('div');
controlsContainer.className = 'example-controls-container';
controls.className = 'controls';
statusOutput.id = 'example1-status';
retryButton.type = 'button';
retryButton.textContent = 'Retry';
retryButton.hidden = true;
controls.appendChild(retryButton);
controlsContainer.appendChild(controls);
controlsContainer.appendChild(statusOutput);
container.appendChild(controlsContainer);
container.appendChild(gridContainer);
const hot = new Handsontable(gridContainer, {
data: [],
colHeaders: ['ID', 'Name', 'Username', 'Email', 'City', 'Company'],
columns: [
{ data: 'id', type: 'numeric', width: 70 },
{ data: 'name', type: 'text', width: 190 },
{ data: 'username', type: 'text', width: 150 },
{ data: 'email', type: 'text', width: 220 },
{ data: 'city', type: 'text', width: 140 },
{ data: 'company', type: 'text', width: 180 },
],
rowHeaders: true,
height: 360,
width: '100%',
stretchH: 'all',
autoWrapRow: true,
licenseKey: 'non-commercial-and-evaluation',
});
function setUiState({ loading = false, hasError = false, message = '' } = {}) {
statusOutput.textContent = message;
statusOutput.classList.toggle('is-error', hasError);
retryButton.hidden = !hasError;
retryButton.disabled = loading;
}
function mapUsersToGridRows(users) {
return users.map((user) => ({
id: user.id,
name: user.name,
username: user.username,
email: user.email,
city: user.address?.city ?? '',
company: user.company?.name ?? '',
}));
}
async function loadUsers() {
setUiState({ loading: true, message: STATUS_LOADING });
try {
const response = await fetch('https://jsonplaceholder.typicode.com/users');
if (!response.ok) {
throw new Error(`Request failed with status: ${response.status}`);
}
const users = await response.json();
hot.loadData(mapUsersToGridRows(users));
setUiState({ message: STATUS_READY });
} catch (_error) {
hot.loadData([]);
setUiState({ hasError: true, message: STATUS_ERROR });
}
}
retryButton.addEventListener('click', () => {
loadUsers();
});
loadUsers();
TypeScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
registerAllModules();
type ApiUser = {
id: number;
name: string;
username: string;
email: string;
address?: { city?: string };
company?: { name?: string };
};
const STATUS_LOADING = 'Loading users...';
const STATUS_READY = 'Loaded users from REST API.';
const STATUS_ERROR = 'Failed to load users. Try again.';
const rootContainer = document.querySelector('#example1') as HTMLDivElement;
const controlsContainer = document.createElement('div');
const controls = document.createElement('div');
const statusOutput = document.createElement('output');
const retryButton = document.createElement('button');
const gridContainer = document.createElement('div');
controlsContainer.className = 'example-controls-container';
controls.className = 'controls';
statusOutput.id = 'example1-status';
retryButton.type = 'button';
retryButton.textContent = 'Retry';
retryButton.hidden = true;
controls.appendChild(retryButton);
controlsContainer.appendChild(controls);
controlsContainer.appendChild(statusOutput);
rootContainer.appendChild(controlsContainer);
rootContainer.appendChild(gridContainer);
const hot = new Handsontable(gridContainer, {
data: [],
colHeaders: ['ID', 'Name', 'Username', 'Email', 'City', 'Company'],
columns: [
{ data: 'id', type: 'numeric', width: 70 },
{ data: 'name', type: 'text', width: 190 },
{ data: 'username', type: 'text', width: 150 },
{ data: 'email', type: 'text', width: 220 },
{ data: 'city', type: 'text', width: 140 },
{ data: 'company', type: 'text', width: 180 },
],
rowHeaders: true,
height: 360,
width: '100%',
stretchH: 'all',
autoWrapRow: true,
licenseKey: 'non-commercial-and-evaluation',
});
function setUiState({
loading = false,
hasError = false,
message = '',
}: {
loading?: boolean;
hasError?: boolean;
message?: string;
}) {
statusOutput.textContent = message;
statusOutput.classList.toggle('is-error', hasError);
retryButton.hidden = !hasError;
retryButton.disabled = loading;
}
function mapUsersToGridRows(users: ApiUser[]) {
return users.map((user) => ({
id: user.id,
name: user.name,
username: user.username,
email: user.email,
city: user.address?.city ?? '',
company: user.company?.name ?? '',
}));
}
async function loadUsers() {
setUiState({ loading: true, message: STATUS_LOADING });
try {
const response = await fetch('https://jsonplaceholder.typicode.com/users');
if (!response.ok) {
throw new Error(`Request failed with status: ${response.status}`);
}
const users = (await response.json()) as ApiUser[];
hot.loadData(mapUsersToGridRows(users));
setUiState({ message: STATUS_READY });
} catch (_error) {
hot.loadData([]);
setUiState({ hasError: true, message: STATUS_ERROR });
}
}
retryButton.addEventListener('click', () => {
loadUsers();
});
loadUsers();

What this recipe covers

  • Fetching data from https://jsonplaceholder.typicode.com/users.
  • Initializing Handsontable with an empty dataset.
  • Filling the table with hot.loadData() when the response arrives.
  • Showing loading, success, and error states in the interface.
  • Defining a column configuration that matches API fields.

How it works

  1. Create Handsontable with data: [].
  2. Create a status element and retry button above the grid.
  3. Start loadUsers() and set status to loading.
  4. Fetch users and map nested fields (company.name, address.city) to flat row objects.
  5. Call hot.loadData(rows) and show a success message.
  6. If the request fails, show an error message and keep the table empty.

Using updateData() to preserve sorting and other states

The first example resets all grid state on every data load — column sort order, selection, and column order all go back to defaults. This is fine when no user state exists yet, but it creates a jarring experience in a running app where the user has already sorted or filtered the data.

hot.updateData() replaces the dataset while keeping every registered grid state intact. The second example demonstrates this: sort any column by clicking its header, then click Refresh. The sort order survives the data update.

JavaScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
registerAllModules();
const STATUS_LOADING = 'Loading users...';
const STATUS_READY =
'Users loaded. Sort a column, then click "Refresh" to see that the column sort order is preserved.';
const STATUS_REFRESHING = 'Refreshing...';
const STATUS_REFRESHED = 'Data refreshed -- column sort order was preserved.';
const STATUS_ERROR = 'Failed to load users. Try again.';
const container = document.querySelector('#example2');
if (!container) {
throw new Error('Missing #example2 element.');
}
const controlsContainer = document.createElement('div');
const controls = document.createElement('div');
const statusOutput = document.createElement('output');
const refreshButton = document.createElement('button');
const retryButton = document.createElement('button');
const gridContainer = document.createElement('div');
controlsContainer.className = 'example-controls-container';
controls.className = 'controls';
statusOutput.id = 'example2-status';
refreshButton.type = 'button';
refreshButton.textContent = 'Refresh';
refreshButton.hidden = true;
retryButton.type = 'button';
retryButton.textContent = 'Retry';
retryButton.hidden = true;
controls.appendChild(refreshButton);
controls.appendChild(retryButton);
controlsContainer.appendChild(controls);
controlsContainer.appendChild(statusOutput);
container.appendChild(controlsContainer);
container.appendChild(gridContainer);
// Step 1: Initialize the grid with columnSorting enabled and an empty dataset.
const hot = new Handsontable(gridContainer, {
data: [],
colHeaders: ['ID', 'Name', 'Username', 'Email', 'City', 'Company'],
columns: [
{ data: 'id', type: 'numeric', width: 70 },
{ data: 'name', type: 'text', width: 190 },
{ data: 'username', type: 'text', width: 150 },
{ data: 'email', type: 'text', width: 220 },
{ data: 'city', type: 'text', width: 140 },
{ data: 'company', type: 'text', width: 180 },
],
// Enables clickable sort indicators on column headers.
columnSorting: true,
rowHeaders: true,
height: 360,
width: '100%',
stretchH: 'all',
autoWrapRow: true,
licenseKey: 'non-commercial-and-evaluation',
});
// Step 2: A helper that keeps the toolbar consistent with the current request state.
function setUiState({ loading = false, hasError = false, message = '' } = {}) {
statusOutput.textContent = message;
statusOutput.classList.toggle('is-error', hasError);
// Show "Retry" only when there is an error.
retryButton.hidden = !hasError;
// Show "Refresh" only when the grid has data and no error is active.
refreshButton.hidden = hasError || loading;
refreshButton.disabled = loading;
retryButton.disabled = loading;
}
// Step 3: Map the API response to flat row objects that match the column definitions.
function mapUsersToGridRows(users) {
return users.map((user) => ({
id: user.id,
name: user.name,
username: user.username,
email: user.email,
city: user.address?.city ?? '',
company: user.company?.name ?? '',
}));
}
// Step 4: Shared fetch helper used by both initialLoad() and refreshUsers().
async function fetchUsers() {
const response = await fetch('https://jsonplaceholder.typicode.com/users');
if (!response.ok) {
throw new Error(`Request failed with status: ${response.status}`);
}
return response.json();
}
// Step 5: Initial load uses loadData(), which resets all grid states.
// This is correct for a first load -- there is no existing state to preserve.
async function initialLoad() {
setUiState({ loading: true, message: STATUS_LOADING });
try {
const users = await fetchUsers();
hot.loadData(mapUsersToGridRows(users));
setUiState({ message: STATUS_READY });
} catch (_error) {
hot.loadData([]);
setUiState({ hasError: true, message: STATUS_ERROR });
}
}
// Step 6: Subsequent refreshes use updateData(), which replaces the data
// without resetting column sort order, selection, or column order.
async function refreshUsers() {
setUiState({ loading: true, message: STATUS_REFRESHING });
try {
const users = await fetchUsers();
hot.updateData(mapUsersToGridRows(users));
setUiState({ message: STATUS_REFRESHED });
} catch (_error) {
// On error, do not clear the grid -- the existing data is still valid.
setUiState({ hasError: true, message: STATUS_ERROR });
}
}
refreshButton.addEventListener('click', () => {
refreshUsers();
});
retryButton.addEventListener('click', () => {
initialLoad();
});
initialLoad();
TypeScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
registerAllModules();
type ApiUser = {
id: number;
name: string;
username: string;
email: string;
address?: { city?: string };
company?: { name?: string };
};
const STATUS_LOADING = 'Loading users...';
const STATUS_READY =
'Users loaded. Sort a column, then click "Refresh" to see that the column sort order is preserved.';
const STATUS_REFRESHING = 'Refreshing...';
const STATUS_REFRESHED = 'Data refreshed -- column sort order was preserved.';
const STATUS_ERROR = 'Failed to load users. Try again.';
const rootContainer = document.querySelector('#example2') as HTMLDivElement;
const controlsContainer = document.createElement('div');
const controls = document.createElement('div');
const statusOutput = document.createElement('output');
const refreshButton = document.createElement('button');
const retryButton = document.createElement('button');
const gridContainer = document.createElement('div');
controlsContainer.className = 'example-controls-container';
controls.className = 'controls';
statusOutput.id = 'example2-status';
refreshButton.type = 'button';
refreshButton.textContent = 'Refresh';
refreshButton.hidden = true;
retryButton.type = 'button';
retryButton.textContent = 'Retry';
retryButton.hidden = true;
controls.appendChild(refreshButton);
controls.appendChild(retryButton);
controlsContainer.appendChild(controls);
controlsContainer.appendChild(statusOutput);
rootContainer.appendChild(controlsContainer);
rootContainer.appendChild(gridContainer);
// Step 1: Initialize the grid with columnSorting enabled and an empty dataset.
const hot = new Handsontable(gridContainer, {
data: [],
colHeaders: ['ID', 'Name', 'Username', 'Email', 'City', 'Company'],
columns: [
{ data: 'id', type: 'numeric', width: 70 },
{ data: 'name', type: 'text', width: 190 },
{ data: 'username', type: 'text', width: 150 },
{ data: 'email', type: 'text', width: 220 },
{ data: 'city', type: 'text', width: 140 },
{ data: 'company', type: 'text', width: 180 },
],
// Enables clickable sort indicators on column headers.
columnSorting: true,
rowHeaders: true,
height: 360,
width: '100%',
stretchH: 'all',
autoWrapRow: true,
licenseKey: 'non-commercial-and-evaluation',
});
// Step 2: A helper that keeps the toolbar consistent with the current request state.
function setUiState({
loading = false,
hasError = false,
message = '',
}: {
loading?: boolean;
hasError?: boolean;
message?: string;
}) {
statusOutput.textContent = message;
statusOutput.classList.toggle('is-error', hasError);
// Show "Retry" only when there is an error.
retryButton.hidden = !hasError;
// Show "Refresh" only when the grid has data and no error is active.
refreshButton.hidden = hasError || loading;
refreshButton.disabled = loading;
retryButton.disabled = loading;
}
// Step 3: Map the API response to flat row objects that match the column definitions.
function mapUsersToGridRows(users: ApiUser[]) {
return users.map((user) => ({
id: user.id,
name: user.name,
username: user.username,
email: user.email,
city: user.address?.city ?? '',
company: user.company?.name ?? '',
}));
}
// Step 4: Shared fetch helper used by both initialLoad() and refreshUsers().
async function fetchUsers(): Promise<ApiUser[]> {
const response = await fetch('https://jsonplaceholder.typicode.com/users');
if (!response.ok) {
throw new Error(`Request failed with status: ${response.status}`);
}
return response.json() as Promise<ApiUser[]>;
}
// Step 5: Initial load uses loadData(), which resets all grid states.
// This is correct for a first load -- there is no existing state to preserve.
async function initialLoad() {
setUiState({ loading: true, message: STATUS_LOADING });
try {
const users = await fetchUsers();
hot.loadData(mapUsersToGridRows(users));
setUiState({ message: STATUS_READY });
} catch (_error) {
hot.loadData([]);
setUiState({ hasError: true, message: STATUS_ERROR });
}
}
// Step 6: Subsequent refreshes use updateData(), which replaces the data
// without resetting column sort order, selection, or column order.
async function refreshUsers() {
setUiState({ loading: true, message: STATUS_REFRESHING });
try {
const users = await fetchUsers();
hot.updateData(mapUsersToGridRows(users));
setUiState({ message: STATUS_REFRESHED });
} catch (_error) {
// On error, do not clear the grid -- the existing data is still valid.
setUiState({ hasError: true, message: STATUS_ERROR });
}
}
refreshButton.addEventListener('click', () => {
refreshUsers();
});
retryButton.addEventListener('click', () => {
initialLoad();
});
initialLoad();

What the second example covers

  • Enabling columnSorting so the user can sort by any column header.
  • Using hot.loadData() for the first fetch — there is no existing state to preserve.
  • Using hot.updateData() for every subsequent refresh to keep column sort order, selection, and column order intact.
  • Extracting a shared fetchUsers() helper that both functions call.
  • Keeping the “Refresh” button hidden until the grid has data, and the “Retry” button visible only on error.

loadData() vs updateData()

Both methods replace the grid’s dataset. The difference is what they reset:

MethodResets sort orderResets selectionResets column orderUse when
loadData()YesYesYesInitial load, schema change, or hard reset
updateData()NoNoNoPeriodic refresh or live-data feed
  1. Enable column sorting

    Add columnSorting: true to the grid options. Handsontable renders a sort-indicator arrow in each column header, and the sort state is preserved by updateData().

    const hot = new Handsontable(gridContainer, {
    data: [],
    // ...column definitions...
    columnSorting: true,
    licenseKey: 'non-commercial-and-evaluation',
    });

    What’s happening:

    • Clicking a column header cycles through ascending, descending, and no sort.
    • The sort state is one of the registered states that updateData() leaves untouched.
    • loadData(), by contrast, resets the sort state to “no sort” on every call.
  2. Add a “Refresh” button to the toolbar

    Create a second button next to the status label and add it to the status bar.

    const refreshButton = document.createElement('button');
    refreshButton.type = 'button';
    refreshButton.textContent = 'Refresh';
    refreshButton.hidden = true; // hidden until the initial load succeeds
    controls.appendChild(refreshButton);

    What’s happening:

    • The button starts hidden so it does not appear during the initial loading phase.
    • setUiState() makes it visible only when the grid contains data and no error is active.
  3. Track four UI states

    The second example has one more status constant than the first — a “Refreshing…” state shown while a refresh is in progress.

    const STATUS_LOADING = 'Loading users...';
    const STATUS_READY = 'Users loaded. Sort a column, then click "Refresh" to see that the column sort order is preserved.';
    const STATUS_REFRESHING = 'Refreshing...';
    const STATUS_REFRESHED = 'Data refreshed -- column sort order was preserved.';
    const STATUS_ERROR = 'Failed to load users. Try again.';

    What’s happening:

    • STATUS_LOADING — shown during the first fetch.
    • STATUS_READY — shown after the first load; prompts the user to sort a column.
    • STATUS_REFRESHING — shown while a refresh request is in flight.
    • STATUS_REFRESHED — shown after a successful refresh; confirms that sort order was kept.
    • STATUS_ERROR — shown when any request fails.
  4. Update setUiState() to manage both buttons

    The helper controls the “Refresh” button alongside the existing “Retry” button.

    function setUiState({ loading = false, hasError = false, message = '' } = {}) {
    statusOutput.textContent = message;
    statusOutput.classList.toggle('is-error', hasError);
    retryButton.hidden = !hasError; // visible only on error
    refreshButton.hidden = hasError || loading; // visible only when data is ready
    refreshButton.disabled = loading;
    retryButton.disabled = loading;
    }

    What’s happening:

    • refreshButton.hidden = hasError || loading — the Refresh button appears only in the “ready” or “refreshed” state.
    • retryButton.hidden = !hasError — the Retry button appears only on error.
    • Both buttons are disabled while any request is in progress to prevent double-clicks.
  5. Extract fetchUsers() as a shared helper

    Both initialLoad() and refreshUsers() need to call the same endpoint. Extract the fetch logic into its own function so neither handler duplicates it.

    async function fetchUsers() {
    const response = await fetch('https://jsonplaceholder.typicode.com/users');
    if (!response.ok) {
    throw new Error(`Request failed with status: ${response.status}`);
    }
    return response.json();
    }

    What’s happening:

    • The function throws when the HTTP status is not 2xx, so callers can catch it in a unified catch block.
    • The mapUsersToGridRows() helper (unchanged from the first example) runs in each caller, keeping fetchUsers() focused on the network concern only.
  6. Use loadData() for the initial fetch

    On the first load there is no state to preserve, so loadData() is the right choice. It also performs a clean reset if the user retries after an error.

    async function initialLoad() {
    setUiState({ loading: true, message: STATUS_LOADING });
    try {
    const users = await fetchUsers();
    hot.loadData(mapUsersToGridRows(users));
    setUiState({ message: STATUS_READY });
    } catch (_error) {
    hot.loadData([]);
    setUiState({ hasError: true, message: STATUS_ERROR });
    }
    }

    What’s happening:

    1. Set the UI to the “Loading…” state and disable both buttons.
    2. Fetch users from the API.
    3. Call hot.loadData() — resets all states (sort order, selection) and renders the fresh data.
    4. On success, show STATUS_READY, which prompts the user to sort a column before refreshing.
    5. On error, clear the grid with hot.loadData([]) and show the Retry button.
  7. Use updateData() for subsequent refreshes

    When the user clicks Refresh, call hot.updateData() instead of hot.loadData(). The grid replaces its data while keeping the sort order exactly as the user left it.

    async function refreshUsers() {
    setUiState({ loading: true, message: STATUS_REFRESHING });
    try {
    const users = await fetchUsers();
    hot.updateData(mapUsersToGridRows(users));
    setUiState({ message: STATUS_REFRESHED });
    } catch (_error) {
    // On error, do not clear the grid -- the existing data is still valid.
    setUiState({ hasError: true, message: STATUS_ERROR });
    }
    }

    What’s happening:

    1. Set the UI to “Refreshing…” and hide the Refresh button.
    2. Fetch users from the API.
    3. Call hot.updateData() — replaces the data while keeping column sort order, selection, and column order intact.
    4. On success, show STATUS_REFRESHED and make the Refresh button available again.
    5. On error, show the Retry button. The grid keeps its current data because updateData() was never called — no data is lost.

    Key difference from loadData():

    • loadData() fires beforeLoadData / afterLoadData hooks and resets all registered state.
    • updateData() fires beforeUpdateData / afterUpdateData hooks and preserves all registered state.

Using dataProvider for automatic pagination and sorting

The first two examples manage the fetch lifecycle yourself: you call loadData() or updateData() at the right time and maintain loading state manually. Handsontable’s dataProvider option flips this model — you provide a fetchRows function and three CRUD callbacks, and the plugin drives everything else: initial load, pagination, column sorting, request cancellation, and loading overlays.

JavaScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
registerAllModules();
// Step 1: Cache the full response after the first request.
// Every subsequent fetchRows call (page change, column sort) reuses this
// without hitting the network again.
let cachedRows = null;
async function loadAllRows(signal) {
if (cachedRows !== null) {
return cachedRows;
}
const response = await fetch('https://jsonplaceholder.typicode.com/users', { signal });
if (!response.ok) {
throw new Error(`HTTP ${response.status}`);
}
const users = await response.json();
cachedRows = users.map((u) => ({
id: u.id,
name: u.name,
username: u.username,
email: u.email,
city: u.address?.city ?? '',
company: u.company?.name ?? '',
}));
return cachedRows;
}
const container = document.querySelector('#example3');
if (!container) {
throw new Error('Missing #example3 element.');
}
const controlsContainer = document.createElement('div');
const statusOutput = document.createElement('output');
const gridContainer = document.createElement('div');
controlsContainer.className = 'example-controls-container';
statusOutput.id = 'example3-status';
statusOutput.textContent = 'Loading...';
container.appendChild(controlsContainer);
controlsContainer.appendChild(statusOutput);
container.appendChild(gridContainer);
new Handsontable(gridContainer, {
// Step 2: Use dataProvider instead of a static data array.
// Handsontable calls fetchRows automatically on init, page change, and sort change.
dataProvider: {
// rowId tells the plugin which field holds the stable row identity.
// It is required for CRUD callbacks and internal refetch tracking.
rowId: 'id',
// Step 3: fetchRows receives current query parameters and an AbortSignal.
// Return { rows, totalRows } so the Pagination plugin knows the total row count.
async fetchRows({ page, pageSize, sort }, { signal }) {
let rows = await loadAllRows(signal);
// Step 4: Apply server-side sort from query parameters.
// In production, pass sort.prop and sort.order to your API instead.
if (sort) {
rows = [...rows].sort((a, b) => {
const av = a[sort.prop];
const bv = b[sort.prop];
const cmp = av < bv ? -1 : av > bv ? 1 : 0;
return sort.order === 'asc' ? cmp : -cmp;
});
}
// Step 5: Apply server-side pagination from query parameters.
// In production, pass page and pageSize to your API instead.
const start = (page - 1) * pageSize;
return {
rows: rows.slice(start, start + pageSize),
totalRows: rows.length,
};
},
// Step 6: CRUD callbacks. jsonplaceholder is read-only, so these are no-ops.
// Replace with POST / PATCH / DELETE calls to a real API.
onRowsCreate: async () => {},
onRowsUpdate: async () => {},
onRowsRemove: async () => {},
},
colHeaders: ['ID', 'Name', 'Username', 'Email', 'City', 'Company'],
columns: [
{ data: 'id', type: 'numeric', width: 70, readOnly: true },
{ data: 'name', type: 'text', width: 190, readOnly: true },
{ data: 'username', type: 'text', width: 150, readOnly: true },
{ data: 'email', type: 'text', width: 220, readOnly: true },
{ data: 'city', type: 'text', width: 140, readOnly: true },
{ data: 'company', type: 'text', width: 180, readOnly: true },
],
// Step 7: Enable the Pagination plugin and pass pageSize so the plugin knows
// how many rows to request. columnSorting enables server-driven sort.
// emptyDataState shows a loading overlay while fetchRows is in flight.
pagination: { pageSize: 5 },
columnSorting: true,
emptyDataState: true,
rowHeaders: true,
height: 360,
width: '100%',
stretchH: 'all',
autoWrapRow: true,
licenseKey: 'non-commercial-and-evaluation',
// Step 8: Use fetch hooks to update the status label.
// skipLoading is true for internal refetches (after sort) -- skip the "Loading..." message
// in those cases so the grid does not flash a spinner on every column header click.
beforeDataProviderFetch: ({ skipLoading }) => {
if (!skipLoading) {
statusOutput.textContent = 'Loading...';
statusOutput.classList.remove('is-error');
}
},
afterDataProviderFetch: () => {
statusOutput.textContent = 'Loaded from REST API via dataProvider.';
statusOutput.classList.remove('is-error');
},
afterDataProviderFetchError: (error) => {
statusOutput.textContent = `Error: ${error.message}`;
statusOutput.classList.add('is-error');
},
});
TypeScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
import type {
DataProviderQueryParameters,
DataProviderFetchOptions,
DataProviderBeforeFetchParameters,
} from 'handsontable/plugins/dataProvider';
registerAllModules();
type UserRow = {
id: number;
name: string;
username: string;
email: string;
city: string;
company: string;
};
// Step 1: Cache the full response after the first request.
// Every subsequent fetchRows call (page change, column sort) reuses this
// without hitting the network again.
let cachedRows: UserRow[] | null = null;
async function loadAllRows(signal: AbortSignal): Promise<UserRow[]> {
if (cachedRows !== null) {
return cachedRows;
}
const response = await fetch('https://jsonplaceholder.typicode.com/users', { signal });
if (!response.ok) {
throw new Error(`HTTP ${response.status}`);
}
const users = (await response.json()) as Array<{
id: number;
name: string;
username: string;
email: string;
address?: { city?: string };
company?: { name?: string };
}>;
cachedRows = users.map((u) => ({
id: u.id,
name: u.name,
username: u.username,
email: u.email,
city: u.address?.city ?? '',
company: u.company?.name ?? '',
}));
return cachedRows;
}
const rootContainer = document.querySelector('#example3') as HTMLDivElement;
const controlsContainer = document.createElement('div');
const statusOutput = document.createElement('output');
const gridContainer = document.createElement('div');
controlsContainer.className = 'example-controls-container';
statusOutput.id = 'example3-status';
statusOutput.textContent = 'Loading...';
rootContainer.appendChild(controlsContainer);
controlsContainer.appendChild(statusOutput);
rootContainer.appendChild(gridContainer);
new Handsontable(gridContainer, {
// Step 2: Use dataProvider instead of a static data array.
// Handsontable calls fetchRows automatically on init, page change, and sort change.
dataProvider: {
// rowId tells the plugin which field holds the stable row identity.
// It is required for CRUD callbacks and internal refetch tracking.
rowId: 'id',
// Step 3: fetchRows receives current query parameters and an AbortSignal.
// Return { rows, totalRows } so the Pagination plugin knows the total row count.
async fetchRows(
{ page, pageSize, sort }: DataProviderQueryParameters,
{ signal }: DataProviderFetchOptions
) {
let rows = await loadAllRows(signal);
// Step 4: Apply server-side sort from query parameters.
// In production, pass sort.prop and sort.order to your API instead.
if (sort) {
rows = [...rows].sort((a, b) => {
const av = a[sort.prop as keyof UserRow];
const bv = b[sort.prop as keyof UserRow];
const cmp = av < bv ? -1 : av > bv ? 1 : 0;
return sort.order === 'asc' ? cmp : -cmp;
});
}
// Step 5: Apply server-side pagination from query parameters.
// In production, pass page and pageSize to your API instead.
const start = (page - 1) * pageSize;
return {
rows: rows.slice(start, start + pageSize),
totalRows: rows.length,
};
},
// Step 6: CRUD callbacks. jsonplaceholder is read-only, so these are no-ops.
// Replace with POST / PATCH / DELETE calls to a real API.
onRowsCreate: async () => {},
onRowsUpdate: async () => {},
onRowsRemove: async () => {},
},
colHeaders: ['ID', 'Name', 'Username', 'Email', 'City', 'Company'],
columns: [
{ data: 'id', type: 'numeric', width: 70, readOnly: true },
{ data: 'name', type: 'text', width: 190, readOnly: true },
{ data: 'username', type: 'text', width: 150, readOnly: true },
{ data: 'email', type: 'text', width: 220, readOnly: true },
{ data: 'city', type: 'text', width: 140, readOnly: true },
{ data: 'company', type: 'text', width: 180, readOnly: true },
],
// Step 7: Enable the Pagination plugin and pass pageSize so the plugin knows
// how many rows to request. columnSorting enables server-driven sort.
// emptyDataState shows a loading overlay while fetchRows is in flight.
pagination: { pageSize: 5 },
columnSorting: true,
emptyDataState: true,
rowHeaders: true,
height: 360,
width: '100%',
stretchH: 'all',
autoWrapRow: true,
licenseKey: 'non-commercial-and-evaluation',
// Step 8: Use fetch hooks to update the status label.
// skipLoading is true for internal refetches (after sort) -- skip the "Loading..." message
// in those cases so the grid does not flash a spinner on every column header click.
beforeDataProviderFetch: ({ skipLoading }: DataProviderBeforeFetchParameters) => {
if (!skipLoading) {
statusOutput.textContent = 'Loading...';
statusOutput.classList.remove('is-error');
}
},
afterDataProviderFetch: () => {
statusOutput.textContent = 'Loaded from REST API via dataProvider.';
statusOutput.classList.remove('is-error');
},
afterDataProviderFetchError: (error: Error) => {
statusOutput.textContent = `Error: ${error.message}`;
statusOutput.classList.add('is-error');
},
});

What the third example covers

  • Configuring dataProvider with rowId, fetchRows, and CRUD callbacks.
  • Sorting rows in fetchRows from the sort query parameter before returning a page.
  • Slicing rows in fetchRows using the page and pageSize query parameters.
  • Enabling pagination, columnSorting, and emptyDataState so the plugin drives navigation and loading overlays.
  • Using beforeDataProviderFetch, afterDataProviderFetch, and afterDataProviderFetchError hooks for status feedback.
  • Passing an AbortSignal to fetch so superseded requests are cancelled automatically.

When to use each approach

ApproachWhen to use
loadData()One-shot load on page init; or when you want to reset all grid state (sort, selection) together with the data.
updateData()Periodic refresh where the user’s sort order, selection, and column layout must survive the data update.
dataProviderBackend-driven pagination, sorting, and filtering; CRUD that round-trips to a server; any dataset too large to keep in the browser.
  1. Cache the remote response

    The dataProvider plugin calls fetchRows every time the user changes page or clicks a sort header. If the API does not support server-side pagination or sorting (as with jsonplaceholder), fetch the full dataset once and reuse it.

    let cachedRows = null;
    async function loadAllRows(signal) {
    if (cachedRows !== null) {
    return cachedRows;
    }
    const response = await fetch('https://jsonplaceholder.typicode.com/users', { signal });
    if (!response.ok) {
    throw new Error(`HTTP ${response.status}`);
    }
    const users = await response.json();
    cachedRows = users.map((u) => ({
    id: u.id, name: u.name, username: u.username,
    email: u.email,
    city: u.address?.city ?? '',
    company: u.company?.name ?? '',
    }));
    return cachedRows;
    }

    What’s happening:

    • cachedRows starts as null. The first call hits the network; every later call returns the same array.
    • signal is the AbortSignal from fetchRows — passing it to fetch cancels the network request if the user sorts or changes pages before the current fetch finishes.
    • The raw API response is mapped to flat row objects that match your columns data keys.

    In production: Pass page, pageSize, sort, and filters directly to your API query string — no client-side caching needed. The client-side sort and slice shown in Steps 4 and 5 replace the server query.

  2. Replace the data array with a dataProvider object

    Instead of passing data: [] and calling hot.loadData(), pass a dataProvider object. Handsontable ignores any data array when the provider is complete.

    new Handsontable(gridContainer, {
    dataProvider: {
    rowId: 'id',
    fetchRows: ...,
    onRowsCreate: async () => {},
    onRowsUpdate: async () => {},
    onRowsRemove: async () => {},
    },
    // ...
    });

    What’s happening:

    • rowId: 'id' tells the plugin which property on each row object carries the stable row identity. It is required for the CRUD callbacks, refetch bookkeeping, and modifyRowHeader numbering across pages.
    • All five keys (rowId, fetchRows, onRowsCreate, onRowsUpdate, onRowsRemove) must be valid for the configuration to be complete. If any are missing, the plugin stays enabled but the affected operations no-op.
  3. Implement fetchRows

    fetchRows is the only required async function. It receives queryParameters and an options object that carries an AbortSignal.

    async fetchRows({ page, pageSize, sort }, { signal }) {
    const rows = await loadAllRows(signal);
    // ...
    return { rows: pagedSlice, totalRows: rows.length };
    }

    What’s happening:

    • page — 1-based page index driven by the Pagination plugin.
    • pageSize — rows per page; matches pagination: { pageSize: 5 } in grid options.
    • sort{ prop, order } object when a column header is sorted, or null when unsorted.
    • { signal } — AbortSignal from the plugin. Pass it to your fetch call so superseded requests are cancelled.
    • Return { rows, totalRows }. totalRows is the unsliced count — the Pagination plugin uses it to calculate the page count and navigation controls.
  4. Apply sort from query parameters

    When sort is non-null, sort a copy of the rows array before slicing. Never mutate the cached array.

    if (sort) {
    rows = [...rows].sort((a, b) => {
    const av = a[sort.prop];
    const bv = b[sort.prop];
    const cmp = av < bv ? -1 : av > bv ? 1 : 0;
    return sort.order === 'asc' ? cmp : -cmp;
    });
    }

    What’s happening:

    • sort.prop is the data key of the sorted column (for example 'name' or 'email').
    • sort.order is 'asc' or 'desc'.
    • The spread [...rows] prevents mutating the cached array. Sorting is referentially transparent — the cache always holds the original order.

    In production: You would not sort in the browser at all. Pass sort.prop and sort.order as query parameters to your API (?_sort=name&_order=asc for jsonplaceholder-style, or your own convention).

  5. Apply pagination from query parameters

    Slice the (sorted) array using page and pageSize.

    const start = (page - 1) * pageSize;
    return {
    rows: rows.slice(start, start + pageSize),
    totalRows: rows.length,
    };

    What’s happening:

    • page is 1-based, so page 1 starts at index 0, page 2 starts at index pageSize, and so on.
    • totalRows is the length of the full sorted array — not the slice. The Pagination plugin uses this to render the correct total page count.

    In production: Pass page and pageSize to your API (?_page=1&_limit=5 for jsonplaceholder) and return the server’s own total or count field as totalRows.

  6. Provide CRUD callbacks

    All three callbacks must be valid functions for the dataProvider configuration to be complete. For a read-only API, return resolved promises without calling the server.

    onRowsCreate: async () => {},
    onRowsUpdate: async () => {},
    onRowsRemove: async () => {},

    What’s happening:

    • The plugin serializes CRUD calls — a second mutation waits for the first to finish.
    • After each callback resolves, the plugin automatically refetches the current page.
    • These no-ops accept any user edit from the context menu but discard it on the next refetch. For a truly read-only grid, set readOnly: true on each column to prevent edits in the first place (as this example does).

    In production: Implement POST, PATCH, and DELETE calls here. See the Server-side data guide for payload shapes and the full CRUD lifecycle.

  7. Enable pagination, columnSorting, and emptyDataState

    pagination: { pageSize: 5 },
    columnSorting: true,
    emptyDataState: true,

    What’s happening:

    • pagination: { pageSize: 5 } enables the Pagination plugin and sets 5 rows per page. The plugin renders navigation controls below the grid and passes page and pageSize into every fetchRows call.
    • columnSorting: true enables server-driven single-column sorting. Clicking a header sets sort in the next fetchRows call. (multiColumnSorting is incompatible with dataProvider — use columnSorting only.)
    • emptyDataState: true renders a loading overlay while fetchRows is in flight and an “empty” state when the response contains zero rows.
  8. Use fetch hooks for status feedback

    beforeDataProviderFetch: ({ skipLoading }) => {
    if (!skipLoading) {
    statusOutput.textContent = 'Loading...';
    statusOutput.classList.remove('is-error');
    }
    },
    afterDataProviderFetch: () => {
    statusOutput.textContent = 'Loaded from REST API via dataProvider.';
    statusOutput.classList.remove('is-error');
    },
    afterDataProviderFetchError: (error) => {
    statusOutput.textContent = `Error: ${error.message}`;
    statusOutput.classList.add('is-error');
    },

    What’s happening:

    • beforeDataProviderFetch fires before every fetch. The skipLoading flag is true for internal refetches triggered after a sort or CRUD operation — skip updating the status label in those cases so the label does not flash “Loading…” on every column header click.
    • afterDataProviderFetch fires after a successful fetch. Update the status label to confirm data was loaded.
    • afterDataProviderFetchError fires when fetchRows rejects with a non-abort error. Update the status label with the error message. If you also set dialog: true in the grid options, the built-in Dialog plugin shows an error modal in addition to this hook.

What you learned

  • How to initialize Handsontable with data: [] and populate it after an async fetch with hot.loadData().
  • How hot.loadData() resets all grid state and hot.updateData() preserves column sort order, selection, and column order on refreshes.
  • How to use beforeDataProviderFetch, afterDataProviderFetch, and afterDataProviderFetchError hooks for status feedback during dataProvider fetches.
  • How the dataProvider architecture handles pagination, server-side sorting, and CRUD automatically — removing the need for manual data management.

Next steps

Skip to content

Load data from a REST API

This tutorial shows how to fetch JSON from a REST API and populate Handsontable after initialization. It starts the grid with data: [], shows a loading message, then displays success or error feedback in the UI.

TypeScript
/* file: app.component.ts */
import { Component, NgZone, ViewChild, AfterViewInit, inject } from '@angular/core';
import { GridSettings, HotTableComponent, HotTableModule } from '@handsontable/angular-wrapper';
type UserRow = {
id: number;
name: string;
username: string;
email: string;
city: string;
company: string;
};
const STATUS_LOADING = 'Loading users...';
const STATUS_READY = 'Loaded users from REST API.';
const STATUS_ERROR = 'Failed to load users. Try again.';
function mapUsersToGridRows(users: Array<{
id: number;
name: string;
username: string;
email: string;
address?: { city?: string };
company?: { name?: string };
}>): UserRow[] {
return users.map((user) => ({
id: user.id,
name: user.name,
username: user.username,
email: user.email,
city: user.address?.city ?? '',
company: user.company?.name ?? '',
}));
}
@Component({
selector: 'example1-load-data-rest-api',
standalone: true,
imports: [HotTableModule],
template: `
<div class="example-controls-container">
<div class="controls">
@if (hasError) {
<button type="button" [disabled]="loading" (click)="loadUsers()">Retry</button>
}
</div>
<output [class.is-error]="hasError">{{ statusMessage }}</output>
</div>
<hot-table [settings]="gridSettings"></hot-table>
`,
})
export class AppComponent implements AfterViewInit {
@ViewChild(HotTableComponent, { static: false }) readonly hotTable!: HotTableComponent;
private readonly ngZone = inject(NgZone);
statusMessage = STATUS_LOADING;
hasError = false;
loading = false;
readonly gridSettings: GridSettings = {
colHeaders: ['ID', 'Name', 'Username', 'Email', 'City', 'Company'],
columns: [
{ data: 'id', type: 'numeric', width: 70, readOnly: true },
{ data: 'name', type: 'text', width: 190, readOnly: true },
{ data: 'username', type: 'text', width: 150, readOnly: true },
{ data: 'email', type: 'text', width: 220, readOnly: true },
{ data: 'city', type: 'text', width: 140, readOnly: true },
{ data: 'company', type: 'text', width: 180, readOnly: true },
],
rowHeaders: true,
height: 360,
width: '100%',
stretchH: 'all',
autoWrapRow: true,
};
private setStatus(message: string, hasError = false): void {
setTimeout(() => {
this.ngZone.run(() => {
this.statusMessage = message;
this.hasError = hasError;
});
}, 0);
}
async loadUsers(): Promise<void> {
this.loading = true;
this.setStatus(STATUS_LOADING);
try {
const response = await fetch('https://jsonplaceholder.typicode.com/users');
if (!response.ok) {
throw new Error(`Request failed with status: ${response.status}`);
}
const users = (await response.json()) as Array<{
id: number;
name: string;
username: string;
email: string;
address?: { city?: string };
company?: { name?: string };
}>;
this.hotTable.hotInstance?.loadData(mapUsersToGridRows(users));
this.setStatus(STATUS_READY);
} catch (_error) {
this.hotTable.hotInstance?.loadData([]);
this.setStatus(STATUS_ERROR, true);
} finally {
this.loading = false;
}
}
ngAfterViewInit(): void {
void this.loadUsers();
}
}
/* end-file */
/* file: app.config.ts */
import { ApplicationConfig, provideZoneChangeDetection } from '@angular/core';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
registerAllModules();
export const appConfig: ApplicationConfig = {
providers: [
provideZoneChangeDetection({ eventCoalescing: true }),
{
provide: HOT_GLOBAL_CONFIG,
useValue: { license: NON_COMMERCIAL_LICENSE } as HotGlobalConfig,
},
],
};
/* end-file */
HTML
<div><example1-load-data-rest-api></example1-load-data-rest-api></div>

What this recipe covers

  • Fetching data from https://jsonplaceholder.typicode.com/users.
  • Initializing Handsontable with an empty dataset.
  • Filling the table with hot.loadData() when the response arrives.
  • Showing loading, success, and error states in the interface.
  • Defining a column configuration that matches API fields.

How it works

  1. Create Handsontable with data: [].
  2. Create a status element and retry button above the grid.
  3. Start loadUsers() and set status to loading.
  4. Fetch users and map nested fields (company.name, address.city) to flat row objects.
  5. Call hot.loadData(rows) and show a success message.
  6. If the request fails, show an error message and keep the table empty.

Using updateData() to preserve sorting and other states

The first example resets all grid state on every data load — column sort order, selection, and column order all go back to defaults. This is fine when no user state exists yet, but it creates a jarring experience in a running app where the user has already sorted or filtered the data.

hot.updateData() replaces the dataset while keeping every registered grid state intact. The second example demonstrates this: sort any column by clicking its header, then click Refresh. The sort order survives the data update.

TypeScript
/* file: app.component.ts */
import { Component, NgZone, ViewChild, AfterViewInit, inject } from '@angular/core';
import { GridSettings, HotTableComponent, HotTableModule } from '@handsontable/angular-wrapper';
type UserRow = {
id: number;
name: string;
username: string;
email: string;
city: string;
company: string;
};
type ApiUser = {
id: number;
name: string;
username: string;
email: string;
address?: { city?: string };
company?: { name?: string };
};
const STATUS_LOADING = 'Loading users...';
const STATUS_READY =
'Users loaded. Sort a column, then click "Refresh" to see that the column sort order is preserved.';
const STATUS_REFRESHING = 'Refreshing...';
const STATUS_REFRESHED = 'Data refreshed -- column sort order was preserved.';
const STATUS_ERROR = 'Failed to load users. Try again.';
function mapUsersToGridRows(users: ApiUser[]): UserRow[] {
return users.map((user) => ({
id: user.id,
name: user.name,
username: user.username,
email: user.email,
city: user.address?.city ?? '',
company: user.company?.name ?? '',
}));
}
@Component({
selector: 'example2-load-data-rest-api',
standalone: true,
imports: [HotTableModule],
template: `
<div class="example-controls-container">
<div class="controls">
@if (hasData && !hasError) {
<button type="button" [disabled]="loading" (click)="refreshUsers()">Refresh</button>
} @else if (hasError) {
<button type="button" [disabled]="loading" (click)="initialLoad()">Retry</button>
}
</div>
<output [class.is-error]="hasError">{{ statusMessage }}</output>
</div>
<hot-table [settings]="gridSettings"></hot-table>
`,
})
export class AppComponent implements AfterViewInit {
@ViewChild(HotTableComponent, { static: false }) readonly hotTable!: HotTableComponent;
private readonly ngZone = inject(NgZone);
statusMessage = STATUS_LOADING;
hasError = false;
hasData = false;
loading = false;
readonly gridSettings: GridSettings = {
colHeaders: ['ID', 'Name', 'Username', 'Email', 'City', 'Company'],
columns: [
{ data: 'id', type: 'numeric', width: 70, readOnly: true },
{ data: 'name', type: 'text', width: 190, readOnly: true },
{ data: 'username', type: 'text', width: 150, readOnly: true },
{ data: 'email', type: 'text', width: 220, readOnly: true },
{ data: 'city', type: 'text', width: 140, readOnly: true },
{ data: 'company', type: 'text', width: 180, readOnly: true },
],
columnSorting: true,
rowHeaders: true,
height: 360,
width: '100%',
stretchH: 'all',
autoWrapRow: true,
};
private setStatus(message: string, hasError = false): void {
setTimeout(() => {
this.ngZone.run(() => {
this.statusMessage = message;
this.hasError = hasError;
});
}, 0);
}
private async fetchUsers(): Promise<ApiUser[]> {
const response = await fetch('https://jsonplaceholder.typicode.com/users');
if (!response.ok) {
throw new Error(`Request failed with status: ${response.status}`);
}
return response.json() as Promise<ApiUser[]>;
}
async initialLoad(): Promise<void> {
this.loading = true;
this.setStatus(STATUS_LOADING);
try {
const users = await this.fetchUsers();
this.hotTable.hotInstance?.loadData(mapUsersToGridRows(users));
this.hasData = true;
this.setStatus(STATUS_READY);
} catch (_error) {
this.hotTable.hotInstance?.loadData([]);
this.setStatus(STATUS_ERROR, true);
} finally {
this.loading = false;
}
}
async refreshUsers(): Promise<void> {
this.loading = true;
this.setStatus(STATUS_REFRESHING);
try {
const users = await this.fetchUsers();
this.hotTable.hotInstance?.updateData(mapUsersToGridRows(users));
this.setStatus(STATUS_REFRESHED);
} catch (_error) {
this.setStatus(STATUS_ERROR, true);
} finally {
this.loading = false;
}
}
ngAfterViewInit(): void {
void this.initialLoad();
}
}
/* end-file */
/* file: app.config.ts */
import { ApplicationConfig, provideZoneChangeDetection } from '@angular/core';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
registerAllModules();
export const appConfig: ApplicationConfig = {
providers: [
provideZoneChangeDetection({ eventCoalescing: true }),
{
provide: HOT_GLOBAL_CONFIG,
useValue: { license: NON_COMMERCIAL_LICENSE } as HotGlobalConfig,
},
],
};
/* end-file */
HTML
<div><example2-load-data-rest-api></example2-load-data-rest-api></div>

What the second example covers

  • Enabling columnSorting so the user can sort by any column header.
  • Using hot.loadData() for the first fetch — there is no existing state to preserve.
  • Using hot.updateData() for every subsequent refresh to keep column sort order, selection, and column order intact.
  • Extracting a shared fetchUsers() helper that both functions call.
  • Keeping the “Refresh” button hidden until the grid has data, and the “Retry” button visible only on error.

loadData() vs updateData()

Both methods replace the grid’s dataset. The difference is what they reset:

MethodResets sort orderResets selectionResets column orderUse when
loadData()YesYesYesInitial load, schema change, or hard reset
updateData()NoNoNoPeriodic refresh or live-data feed
  1. Enable column sorting

    Add columnSorting: true to the grid options. Handsontable renders a sort-indicator arrow in each column header, and the sort state is preserved by updateData().

    const hot = new Handsontable(gridContainer, {
    data: [],
    // ...column definitions...
    columnSorting: true,
    licenseKey: 'non-commercial-and-evaluation',
    });

    What’s happening:

    • Clicking a column header cycles through ascending, descending, and no sort.
    • The sort state is one of the registered states that updateData() leaves untouched.
    • loadData(), by contrast, resets the sort state to “no sort” on every call.
  2. Add a “Refresh” button to the toolbar

    Create a second button next to the status label and add it to the status bar.

    const refreshButton = document.createElement('button');
    refreshButton.type = 'button';
    refreshButton.textContent = 'Refresh';
    refreshButton.hidden = true; // hidden until the initial load succeeds
    controls.appendChild(refreshButton);

    What’s happening:

    • The button starts hidden so it does not appear during the initial loading phase.
    • setUiState() makes it visible only when the grid contains data and no error is active.
  3. Track four UI states

    The second example has one more status constant than the first — a “Refreshing…” state shown while a refresh is in progress.

    const STATUS_LOADING = 'Loading users...';
    const STATUS_READY = 'Users loaded. Sort a column, then click "Refresh" to see that the column sort order is preserved.';
    const STATUS_REFRESHING = 'Refreshing...';
    const STATUS_REFRESHED = 'Data refreshed -- column sort order was preserved.';
    const STATUS_ERROR = 'Failed to load users. Try again.';

    What’s happening:

    • STATUS_LOADING — shown during the first fetch.
    • STATUS_READY — shown after the first load; prompts the user to sort a column.
    • STATUS_REFRESHING — shown while a refresh request is in flight.
    • STATUS_REFRESHED — shown after a successful refresh; confirms that sort order was kept.
    • STATUS_ERROR — shown when any request fails.
  4. Update setUiState() to manage both buttons

    The helper controls the “Refresh” button alongside the existing “Retry” button.

    function setUiState({ loading = false, hasError = false, message = '' } = {}) {
    statusOutput.textContent = message;
    statusOutput.classList.toggle('is-error', hasError);
    retryButton.hidden = !hasError; // visible only on error
    refreshButton.hidden = hasError || loading; // visible only when data is ready
    refreshButton.disabled = loading;
    retryButton.disabled = loading;
    }

    What’s happening:

    • refreshButton.hidden = hasError || loading — the Refresh button appears only in the “ready” or “refreshed” state.
    • retryButton.hidden = !hasError — the Retry button appears only on error.
    • Both buttons are disabled while any request is in progress to prevent double-clicks.
  5. Extract fetchUsers() as a shared helper

    Both initialLoad() and refreshUsers() need to call the same endpoint. Extract the fetch logic into its own function so neither handler duplicates it.

    async function fetchUsers() {
    const response = await fetch('https://jsonplaceholder.typicode.com/users');
    if (!response.ok) {
    throw new Error(`Request failed with status: ${response.status}`);
    }
    return response.json();
    }

    What’s happening:

    • The function throws when the HTTP status is not 2xx, so callers can catch it in a unified catch block.
    • The mapUsersToGridRows() helper (unchanged from the first example) runs in each caller, keeping fetchUsers() focused on the network concern only.
  6. Use loadData() for the initial fetch

    On the first load there is no state to preserve, so loadData() is the right choice. It also performs a clean reset if the user retries after an error.

    async function initialLoad() {
    setUiState({ loading: true, message: STATUS_LOADING });
    try {
    const users = await fetchUsers();
    hot.loadData(mapUsersToGridRows(users));
    setUiState({ message: STATUS_READY });
    } catch (_error) {
    hot.loadData([]);
    setUiState({ hasError: true, message: STATUS_ERROR });
    }
    }

    What’s happening:

    1. Set the UI to the “Loading…” state and disable both buttons.
    2. Fetch users from the API.
    3. Call hot.loadData() — resets all states (sort order, selection) and renders the fresh data.
    4. On success, show STATUS_READY, which prompts the user to sort a column before refreshing.
    5. On error, clear the grid with hot.loadData([]) and show the Retry button.
  7. Use updateData() for subsequent refreshes

    When the user clicks Refresh, call hot.updateData() instead of hot.loadData(). The grid replaces its data while keeping the sort order exactly as the user left it.

    async function refreshUsers() {
    setUiState({ loading: true, message: STATUS_REFRESHING });
    try {
    const users = await fetchUsers();
    hot.updateData(mapUsersToGridRows(users));
    setUiState({ message: STATUS_REFRESHED });
    } catch (_error) {
    // On error, do not clear the grid -- the existing data is still valid.
    setUiState({ hasError: true, message: STATUS_ERROR });
    }
    }

    What’s happening:

    1. Set the UI to “Refreshing…” and hide the Refresh button.
    2. Fetch users from the API.
    3. Call hot.updateData() — replaces the data while keeping column sort order, selection, and column order intact.
    4. On success, show STATUS_REFRESHED and make the Refresh button available again.
    5. On error, show the Retry button. The grid keeps its current data because updateData() was never called — no data is lost.

    Key difference from loadData():

    • loadData() fires beforeLoadData / afterLoadData hooks and resets all registered state.
    • updateData() fires beforeUpdateData / afterUpdateData hooks and preserves all registered state.

Using dataProvider for automatic pagination and sorting

The first two examples manage the fetch lifecycle yourself: you call loadData() or updateData() at the right time and maintain loading state manually. Handsontable’s dataProvider option flips this model — you provide a fetchRows function and three CRUD callbacks, and the plugin drives everything else: initial load, pagination, column sorting, request cancellation, and loading overlays.

TypeScript
/* file: app.component.ts */
import { Component, NgZone, inject } from '@angular/core';
import { GridSettings, HotTableModule } from '@handsontable/angular-wrapper';
import type {
DataProviderQueryParameters,
DataProviderFetchOptions,
DataProviderBeforeFetchParameters,
} from 'handsontable/plugins/dataProvider';
type UserRow = {
id: number;
name: string;
username: string;
email: string;
city: string;
company: string;
};
@Component({
selector: 'example3-load-data-rest-api',
standalone: true,
imports: [HotTableModule],
template: `
<div class="example-controls-container">
<output [class.is-error]="statusIsError">{{ statusMessage }}</output>
</div>
<hot-table [settings]="hotSettings"></hot-table>
`,
})
export class AppComponent {
private readonly ngZone = inject(NgZone);
statusIsError = false;
statusMessage = 'Loading...';
private cachedRows: UserRow[] | null = null;
readonly hotSettings: GridSettings;
/** Defers binding updates so sync data-provider hooks do not trigger NG0100 in dev mode. */
private setFetchStatus(message: string, isError = false): void {
setTimeout(() => {
this.ngZone.run(() => {
this.statusMessage = message;
this.statusIsError = isError;
});
}, 0);
}
constructor() {
this.hotSettings = {
dataProvider: {
rowId: 'id',
fetchRows: async (
{ page, pageSize, sort }: DataProviderQueryParameters,
{ signal }: DataProviderFetchOptions
) => {
let rows = await this.loadAllRows(signal);
if (sort) {
rows = [...rows].sort((a, b) => {
const av = a[sort.prop as keyof UserRow];
const bv = b[sort.prop as keyof UserRow];
const cmp = av < bv ? -1 : av > bv ? 1 : 0;
return sort.order === 'asc' ? cmp : -cmp;
});
}
const start = (page - 1) * pageSize;
return {
rows: rows.slice(start, start + pageSize),
totalRows: rows.length,
};
},
onRowsCreate: async () => {},
onRowsUpdate: async () => {},
onRowsRemove: async () => {},
},
colHeaders: ['ID', 'Name', 'Username', 'Email', 'City', 'Company'],
columns: [
{ data: 'id', type: 'numeric', width: 70, readOnly: true },
{ data: 'name', type: 'text', width: 190, readOnly: true },
{ data: 'username', type: 'text', width: 150, readOnly: true },
{ data: 'email', type: 'text', width: 220, readOnly: true },
{ data: 'city', type: 'text', width: 140, readOnly: true },
{ data: 'company', type: 'text', width: 180, readOnly: true },
],
pagination: { pageSize: 5 },
columnSorting: true,
emptyDataState: true,
rowHeaders: true,
height: 360,
width: '100%',
stretchH: 'all',
autoWrapRow: true,
beforeDataProviderFetch: (params: DataProviderBeforeFetchParameters) => {
if (!params.skipLoading) {
this.setFetchStatus('Loading...', false);
}
},
afterDataProviderFetch: () => {
this.setFetchStatus('Loaded from REST API via dataProvider.', false);
},
afterDataProviderFetchError: (error: Error) => {
this.setFetchStatus(`Error: ${error.message}`, true);
},
};
}
private async loadAllRows(signal: AbortSignal): Promise<UserRow[]> {
if (this.cachedRows !== null) {
return this.cachedRows;
}
const response = await fetch('https://jsonplaceholder.typicode.com/users', { signal });
if (!response.ok) {
throw new Error(`HTTP ${response.status}`);
}
const users = (await response.json()) as Array<{
id: number;
name: string;
username: string;
email: string;
address?: { city?: string };
company?: { name?: string };
}>;
this.cachedRows = users.map((u) => ({
id: u.id,
name: u.name,
username: u.username,
email: u.email,
city: u.address?.city ?? '',
company: u.company?.name ?? '',
}));
return this.cachedRows;
}
}
/* end-file */
/* file: app.config.ts */
import { ApplicationConfig, provideZoneChangeDetection } from '@angular/core';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
registerAllModules();
export const appConfig: ApplicationConfig = {
providers: [
provideZoneChangeDetection({ eventCoalescing: true }),
{
provide: HOT_GLOBAL_CONFIG,
useValue: { license: NON_COMMERCIAL_LICENSE } as HotGlobalConfig,
},
],
};
/* end-file */
HTML
<div><example3-load-data-rest-api></example3-load-data-rest-api></div>

What the third example covers

  • Configuring dataProvider with rowId, fetchRows, and CRUD callbacks.
  • Sorting rows in fetchRows from the sort query parameter before returning a page.
  • Slicing rows in fetchRows using the page and pageSize query parameters.
  • Enabling pagination, columnSorting, and emptyDataState so the plugin drives navigation and loading overlays.
  • Using beforeDataProviderFetch, afterDataProviderFetch, and afterDataProviderFetchError hooks for status feedback.
  • Passing an AbortSignal to fetch so superseded requests are cancelled automatically.

When to use each approach

ApproachWhen to use
loadData()One-shot load on page init; or when you want to reset all grid state (sort, selection) together with the data.
updateData()Periodic refresh where the user’s sort order, selection, and column layout must survive the data update.
dataProviderBackend-driven pagination, sorting, and filtering; CRUD that round-trips to a server; any dataset too large to keep in the browser.
  1. Cache the remote response

    The dataProvider plugin calls fetchRows every time the user changes page or clicks a sort header. If the API does not support server-side pagination or sorting (as with jsonplaceholder), fetch the full dataset once and reuse it.

    let cachedRows = null;
    async function loadAllRows(signal) {
    if (cachedRows !== null) {
    return cachedRows;
    }
    const response = await fetch('https://jsonplaceholder.typicode.com/users', { signal });
    if (!response.ok) {
    throw new Error(`HTTP ${response.status}`);
    }
    const users = await response.json();
    cachedRows = users.map((u) => ({
    id: u.id, name: u.name, username: u.username,
    email: u.email,
    city: u.address?.city ?? '',
    company: u.company?.name ?? '',
    }));
    return cachedRows;
    }

    What’s happening:

    • cachedRows starts as null. The first call hits the network; every later call returns the same array.
    • signal is the AbortSignal from fetchRows — passing it to fetch cancels the network request if the user sorts or changes pages before the current fetch finishes.
    • The raw API response is mapped to flat row objects that match your columns data keys.

    In production: Pass page, pageSize, sort, and filters directly to your API query string — no client-side caching needed. The client-side sort and slice shown in Steps 4 and 5 replace the server query.

  2. Replace the data array with a dataProvider object

    Instead of passing data: [] and calling hot.loadData(), pass a dataProvider object. Handsontable ignores any data array when the provider is complete.

    new Handsontable(gridContainer, {
    dataProvider: {
    rowId: 'id',
    fetchRows: ...,
    onRowsCreate: async () => {},
    onRowsUpdate: async () => {},
    onRowsRemove: async () => {},
    },
    // ...
    });

    What’s happening:

    • rowId: 'id' tells the plugin which property on each row object carries the stable row identity. It is required for the CRUD callbacks, refetch bookkeeping, and modifyRowHeader numbering across pages.
    • All five keys (rowId, fetchRows, onRowsCreate, onRowsUpdate, onRowsRemove) must be valid for the configuration to be complete. If any are missing, the plugin stays enabled but the affected operations no-op.
  3. Implement fetchRows

    fetchRows is the only required async function. It receives queryParameters and an options object that carries an AbortSignal.

    async fetchRows({ page, pageSize, sort }, { signal }) {
    const rows = await loadAllRows(signal);
    // ...
    return { rows: pagedSlice, totalRows: rows.length };
    }

    What’s happening:

    • page — 1-based page index driven by the Pagination plugin.
    • pageSize — rows per page; matches pagination: { pageSize: 5 } in grid options.
    • sort{ prop, order } object when a column header is sorted, or null when unsorted.
    • { signal } — AbortSignal from the plugin. Pass it to your fetch call so superseded requests are cancelled.
    • Return { rows, totalRows }. totalRows is the unsliced count — the Pagination plugin uses it to calculate the page count and navigation controls.
  4. Apply sort from query parameters

    When sort is non-null, sort a copy of the rows array before slicing. Never mutate the cached array.

    if (sort) {
    rows = [...rows].sort((a, b) => {
    const av = a[sort.prop];
    const bv = b[sort.prop];
    const cmp = av < bv ? -1 : av > bv ? 1 : 0;
    return sort.order === 'asc' ? cmp : -cmp;
    });
    }

    What’s happening:

    • sort.prop is the data key of the sorted column (for example 'name' or 'email').
    • sort.order is 'asc' or 'desc'.
    • The spread [...rows] prevents mutating the cached array. Sorting is referentially transparent — the cache always holds the original order.

    In production: You would not sort in the browser at all. Pass sort.prop and sort.order as query parameters to your API (?_sort=name&_order=asc for jsonplaceholder-style, or your own convention).

  5. Apply pagination from query parameters

    Slice the (sorted) array using page and pageSize.

    const start = (page - 1) * pageSize;
    return {
    rows: rows.slice(start, start + pageSize),
    totalRows: rows.length,
    };

    What’s happening:

    • page is 1-based, so page 1 starts at index 0, page 2 starts at index pageSize, and so on.
    • totalRows is the length of the full sorted array — not the slice. The Pagination plugin uses this to render the correct total page count.

    In production: Pass page and pageSize to your API (?_page=1&_limit=5 for jsonplaceholder) and return the server’s own total or count field as totalRows.

  6. Provide CRUD callbacks

    All three callbacks must be valid functions for the dataProvider configuration to be complete. For a read-only API, return resolved promises without calling the server.

    onRowsCreate: async () => {},
    onRowsUpdate: async () => {},
    onRowsRemove: async () => {},

    What’s happening:

    • The plugin serializes CRUD calls — a second mutation waits for the first to finish.
    • After each callback resolves, the plugin automatically refetches the current page.
    • These no-ops accept any user edit from the context menu but discard it on the next refetch. For a truly read-only grid, set readOnly: true on each column to prevent edits in the first place (as this example does).

    In production: Implement POST, PATCH, and DELETE calls here. See the Server-side data guide for payload shapes and the full CRUD lifecycle.

  7. Enable pagination, columnSorting, and emptyDataState

    pagination: { pageSize: 5 },
    columnSorting: true,
    emptyDataState: true,

    What’s happening:

    • pagination: { pageSize: 5 } enables the Pagination plugin and sets 5 rows per page. The plugin renders navigation controls below the grid and passes page and pageSize into every fetchRows call.
    • columnSorting: true enables server-driven single-column sorting. Clicking a header sets sort in the next fetchRows call. (multiColumnSorting is incompatible with dataProvider — use columnSorting only.)
    • emptyDataState: true renders a loading overlay while fetchRows is in flight and an “empty” state when the response contains zero rows.
  8. Use fetch hooks for status feedback

    beforeDataProviderFetch: ({ skipLoading }) => {
    if (!skipLoading) {
    statusOutput.textContent = 'Loading...';
    statusOutput.classList.remove('is-error');
    }
    },
    afterDataProviderFetch: () => {
    statusOutput.textContent = 'Loaded from REST API via dataProvider.';
    statusOutput.classList.remove('is-error');
    },
    afterDataProviderFetchError: (error) => {
    statusOutput.textContent = `Error: ${error.message}`;
    statusOutput.classList.add('is-error');
    },

    What’s happening:

    • beforeDataProviderFetch fires before every fetch. The skipLoading flag is true for internal refetches triggered after a sort or CRUD operation — skip updating the status label in those cases so the label does not flash “Loading…” on every column header click.
    • afterDataProviderFetch fires after a successful fetch. Update the status label to confirm data was loaded.
    • afterDataProviderFetchError fires when fetchRows rejects with a non-abort error. Update the status label with the error message. If you also set dialog: true in the grid options, the built-in Dialog plugin shows an error modal in addition to this hook.

What you learned

  • How to initialize Handsontable with data: [] and populate it after an async fetch with hot.loadData().
  • How hot.loadData() resets all grid state and hot.updateData() preserves column sort order, selection, and column order on refreshes.
  • How to use beforeDataProviderFetch, afterDataProviderFetch, and afterDataProviderFetchError hooks for status feedback during dataProvider fetches.
  • How the dataProvider architecture handles pagination, server-side sorting, and CRUD automatically — removing the need for manual data management.

Next steps

Skip to content

Load data from a REST API

This tutorial shows how to fetch JSON from a REST API and populate Handsontable after initialization. It starts the grid with data: [], shows a loading message, then displays success or error feedback in the UI.

JavaScript
import { useState, useEffect } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
registerAllModules();
const STATUS_LOADING = 'Loading users...';
const STATUS_READY = 'Loaded users from REST API.';
const STATUS_ERROR = 'Failed to load users. Try again.';
async function fetchUsers() {
const response = await fetch('https://jsonplaceholder.typicode.com/users');
if (!response.ok) {
throw new Error(`Request failed with status: ${response.status}`);
}
return response.json();
}
function mapUsersToGridRows(users) {
return users.map((user) => ({
id: user.id,
name: user.name,
username: user.username,
email: user.email,
city: user.address?.city ?? '',
company: user.company?.name ?? '',
}));
}
const ExampleComponent = () => {
const [rows, setRows] = useState([]);
const [status, setStatus] = useState(STATUS_LOADING);
const [hasError, setHasError] = useState(false);
const loadUsers = async () => {
setStatus(STATUS_LOADING);
setHasError(false);
try {
const users = await fetchUsers();
setRows(mapUsersToGridRows(users));
setStatus(STATUS_READY);
} catch (_error) {
setRows([]);
setHasError(true);
setStatus(STATUS_ERROR);
}
};
// eslint-disable-next-line react-hooks/exhaustive-deps
useEffect(() => { loadUsers(); }, []);
return (
<div>
<div className="example-controls-container">
<div className="controls">
{hasError && (
<button type="button" onClick={loadUsers} disabled={status === STATUS_LOADING}>
Retry
</button>
)}
</div>
<output className={hasError ? 'is-error' : undefined}>{status}</output>
</div>
<HotTable
data={rows}
colHeaders={['ID', 'Name', 'Username', 'Email', 'City', 'Company']}
columns={[
{ data: 'id', type: 'numeric', width: 70, readOnly: true },
{ data: 'name', type: 'text', width: 190, readOnly: true },
{ data: 'username', type: 'text', width: 150, readOnly: true },
{ data: 'email', type: 'text', width: 220, readOnly: true },
{ data: 'city', type: 'text', width: 140, readOnly: true },
{ data: 'company', type: 'text', width: 180, readOnly: true },
]}
rowHeaders={true}
height={360}
width="100%"
stretchH="all"
autoWrapRow={true}
licenseKey="non-commercial-and-evaluation"
/>
</div>
);
};
export default ExampleComponent;
TypeScript
import { useState, useEffect } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
registerAllModules();
type ApiUser = {
id: number;
name: string;
username: string;
email: string;
address?: { city?: string };
company?: { name?: string };
};
type UserRow = {
id: number;
name: string;
username: string;
email: string;
city: string;
company: string;
};
const STATUS_LOADING = 'Loading users...';
const STATUS_READY = 'Loaded users from REST API.';
const STATUS_ERROR = 'Failed to load users. Try again.';
async function fetchUsers(): Promise<ApiUser[]> {
const response = await fetch('https://jsonplaceholder.typicode.com/users');
if (!response.ok) {
throw new Error(`Request failed with status: ${response.status}`);
}
return response.json() as Promise<ApiUser[]>;
}
function mapUsersToGridRows(users: ApiUser[]): UserRow[] {
return users.map((user) => ({
id: user.id,
name: user.name,
username: user.username,
email: user.email,
city: user.address?.city ?? '',
company: user.company?.name ?? '',
}));
}
const ExampleComponent = () => {
const [rows, setRows] = useState<UserRow[]>([]);
const [status, setStatus] = useState(STATUS_LOADING);
const [hasError, setHasError] = useState(false);
const loadUsers = async () => {
setStatus(STATUS_LOADING);
setHasError(false);
try {
const users = await fetchUsers();
setRows(mapUsersToGridRows(users));
setStatus(STATUS_READY);
} catch (_error) {
setRows([]);
setHasError(true);
setStatus(STATUS_ERROR);
}
};
// eslint-disable-next-line react-hooks/exhaustive-deps
useEffect(() => { loadUsers(); }, []);
return (
<div>
<div className="example-controls-container">
<div className="controls">
{hasError && (
<button type="button" onClick={loadUsers} disabled={status === STATUS_LOADING}>
Retry
</button>
)}
</div>
<output className={hasError ? 'is-error' : undefined}>{status}</output>
</div>
<HotTable
data={rows}
colHeaders={['ID', 'Name', 'Username', 'Email', 'City', 'Company']}
columns={[
{ data: 'id', type: 'numeric', width: 70, readOnly: true },
{ data: 'name', type: 'text', width: 190, readOnly: true },
{ data: 'username', type: 'text', width: 150, readOnly: true },
{ data: 'email', type: 'text', width: 220, readOnly: true },
{ data: 'city', type: 'text', width: 140, readOnly: true },
{ data: 'company', type: 'text', width: 180, readOnly: true },
]}
rowHeaders={true}
height={360}
width="100%"
stretchH="all"
autoWrapRow={true}
licenseKey="non-commercial-and-evaluation"
/>
</div>
);
};
export default ExampleComponent;

What this recipe covers

  • Fetching data from https://jsonplaceholder.typicode.com/users.
  • Initializing Handsontable with an empty dataset.
  • Filling the table with hot.loadData() when the response arrives.
  • Showing loading, success, and error states in the interface.
  • Defining a column configuration that matches API fields.

How it works

  1. Create Handsontable with data: [].
  2. Create a status element and retry button above the grid.
  3. Start loadUsers() and set status to loading.
  4. Fetch users and map nested fields (company.name, address.city) to flat row objects.
  5. Call hot.loadData(rows) and show a success message.
  6. If the request fails, show an error message and keep the table empty.

Using updateData() to preserve sorting and other states

The first example resets all grid state on every data load — column sort order, selection, and column order all go back to defaults. This is fine when no user state exists yet, but it creates a jarring experience in a running app where the user has already sorted or filtered the data.

hot.updateData() replaces the dataset while keeping every registered grid state intact. The second example demonstrates this: sort any column by clicking its header, then click Refresh. The sort order survives the data update.

JavaScript
import { useState, useEffect, useRef } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
registerAllModules();
const STATUS_LOADING = 'Loading users...';
const STATUS_READY =
'Users loaded. Sort a column, then click "Refresh" to see that the column sort order is preserved.';
const STATUS_REFRESHING = 'Refreshing...';
const STATUS_REFRESHED = 'Data refreshed -- column sort order was preserved.';
const STATUS_ERROR = 'Failed to load users. Try again.';
async function fetchUsers() {
const response = await fetch('https://jsonplaceholder.typicode.com/users');
if (!response.ok) {
throw new Error(`Request failed with status: ${response.status}`);
}
return response.json();
}
function mapUsersToGridRows(users) {
return users.map((user) => ({
id: user.id,
name: user.name,
username: user.username,
email: user.email,
city: user.address?.city ?? '',
company: user.company?.name ?? '',
}));
}
const ExampleComponent = () => {
const hotRef = useRef(null);
const [status, setStatus] = useState(STATUS_LOADING);
const [hasError, setHasError] = useState(false);
const [showRefresh, setShowRefresh] = useState(false);
const initialLoad = async () => {
setStatus(STATUS_LOADING);
setHasError(false);
setShowRefresh(false);
try {
const users = await fetchUsers();
hotRef.current?.hotInstance?.loadData(mapUsersToGridRows(users));
setStatus(STATUS_READY);
setShowRefresh(true);
} catch (_error) {
hotRef.current?.hotInstance?.loadData([]);
setHasError(true);
setStatus(STATUS_ERROR);
}
};
const refreshUsers = async () => {
setStatus(STATUS_REFRESHING);
setHasError(false);
setShowRefresh(false);
try {
const users = await fetchUsers();
hotRef.current?.hotInstance?.updateData(mapUsersToGridRows(users));
setStatus(STATUS_REFRESHED);
setShowRefresh(true);
} catch (_error) {
setHasError(true);
setStatus(STATUS_ERROR);
}
};
// eslint-disable-next-line react-hooks/exhaustive-deps
useEffect(() => { initialLoad(); }, []);
return (
<div>
<div className="example-controls-container">
<div className="controls">
{showRefresh && !hasError && (
<button
type="button"
onClick={refreshUsers}
disabled={status === STATUS_LOADING || status === STATUS_REFRESHING}
>
Refresh
</button>
)}
{hasError && (
<button
type="button"
onClick={initialLoad}
disabled={status === STATUS_LOADING || status === STATUS_REFRESHING}
>
Retry
</button>
)}
</div>
<output className={hasError ? 'is-error' : undefined}>{status}</output>
</div>
<HotTable
ref={hotRef}
colHeaders={['ID', 'Name', 'Username', 'Email', 'City', 'Company']}
columns={[
{ data: 'id', type: 'numeric', width: 70, readOnly: true },
{ data: 'name', type: 'text', width: 190, readOnly: true },
{ data: 'username', type: 'text', width: 150, readOnly: true },
{ data: 'email', type: 'text', width: 220, readOnly: true },
{ data: 'city', type: 'text', width: 140, readOnly: true },
{ data: 'company', type: 'text', width: 180, readOnly: true },
]}
columnSorting={true}
rowHeaders={true}
height={360}
width="100%"
stretchH="all"
autoWrapRow={true}
licenseKey="non-commercial-and-evaluation"
/>
</div>
);
};
export default ExampleComponent;
TypeScript
import { useState, useEffect, useRef } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
registerAllModules();
type ApiUser = {
id: number;
name: string;
username: string;
email: string;
address?: { city?: string };
company?: { name?: string };
};
type UserRow = {
id: number;
name: string;
username: string;
email: string;
city: string;
company: string;
};
const STATUS_LOADING = 'Loading users...';
const STATUS_READY =
'Users loaded. Sort a column, then click "Refresh" to see that the column sort order is preserved.';
const STATUS_REFRESHING = 'Refreshing...';
const STATUS_REFRESHED = 'Data refreshed -- column sort order was preserved.';
const STATUS_ERROR = 'Failed to load users. Try again.';
async function fetchUsers(): Promise<ApiUser[]> {
const response = await fetch('https://jsonplaceholder.typicode.com/users');
if (!response.ok) {
throw new Error(`Request failed with status: ${response.status}`);
}
return response.json() as Promise<ApiUser[]>;
}
function mapUsersToGridRows(users: ApiUser[]): UserRow[] {
return users.map((user) => ({
id: user.id,
name: user.name,
username: user.username,
email: user.email,
city: user.address?.city ?? '',
company: user.company?.name ?? '',
}));
}
const ExampleComponent = () => {
const hotRef = useRef<InstanceType<typeof HotTable>>(null);
const [status, setStatus] = useState(STATUS_LOADING);
const [hasError, setHasError] = useState(false);
const [showRefresh, setShowRefresh] = useState(false);
const initialLoad = async () => {
setStatus(STATUS_LOADING);
setHasError(false);
setShowRefresh(false);
try {
const users = await fetchUsers();
hotRef.current?.hotInstance?.loadData(mapUsersToGridRows(users));
setStatus(STATUS_READY);
setShowRefresh(true);
} catch (_error) {
hotRef.current?.hotInstance?.loadData([]);
setHasError(true);
setStatus(STATUS_ERROR);
}
};
const refreshUsers = async () => {
setStatus(STATUS_REFRESHING);
setHasError(false);
setShowRefresh(false);
try {
const users = await fetchUsers();
hotRef.current?.hotInstance?.updateData(mapUsersToGridRows(users));
setStatus(STATUS_REFRESHED);
setShowRefresh(true);
} catch (_error) {
setHasError(true);
setStatus(STATUS_ERROR);
}
};
// eslint-disable-next-line react-hooks/exhaustive-deps
useEffect(() => { initialLoad(); }, []);
return (
<div>
<div className="example-controls-container">
<div className="controls">
{showRefresh && !hasError && (
<button
type="button"
onClick={refreshUsers}
disabled={status === STATUS_LOADING || status === STATUS_REFRESHING}
>
Refresh
</button>
)}
{hasError && (
<button
type="button"
onClick={initialLoad}
disabled={status === STATUS_LOADING || status === STATUS_REFRESHING}
>
Retry
</button>
)}
</div>
<output className={hasError ? 'is-error' : undefined}>{status}</output>
</div>
<HotTable
ref={hotRef}
colHeaders={['ID', 'Name', 'Username', 'Email', 'City', 'Company']}
columns={[
{ data: 'id', type: 'numeric', width: 70, readOnly: true },
{ data: 'name', type: 'text', width: 190, readOnly: true },
{ data: 'username', type: 'text', width: 150, readOnly: true },
{ data: 'email', type: 'text', width: 220, readOnly: true },
{ data: 'city', type: 'text', width: 140, readOnly: true },
{ data: 'company', type: 'text', width: 180, readOnly: true },
]}
columnSorting={true}
rowHeaders={true}
height={360}
width="100%"
stretchH="all"
autoWrapRow={true}
licenseKey="non-commercial-and-evaluation"
/>
</div>
);
};
export default ExampleComponent;

What the second example covers

  • Enabling columnSorting so the user can sort by any column header.
  • Using hot.loadData() for the first fetch — there is no existing state to preserve.
  • Using hot.updateData() for every subsequent refresh to keep column sort order, selection, and column order intact.
  • Extracting a shared fetchUsers() helper that both functions call.
  • Keeping the “Refresh” button hidden until the grid has data, and the “Retry” button visible only on error.

loadData() vs updateData()

Both methods replace the grid’s dataset. The difference is what they reset:

MethodResets sort orderResets selectionResets column orderUse when
loadData()YesYesYesInitial load, schema change, or hard reset
updateData()NoNoNoPeriodic refresh or live-data feed
  1. Enable column sorting

    Add columnSorting: true to the grid options. Handsontable renders a sort-indicator arrow in each column header, and the sort state is preserved by updateData().

    const hot = new Handsontable(gridContainer, {
    data: [],
    // ...column definitions...
    columnSorting: true,
    licenseKey: 'non-commercial-and-evaluation',
    });

    What’s happening:

    • Clicking a column header cycles through ascending, descending, and no sort.
    • The sort state is one of the registered states that updateData() leaves untouched.
    • loadData(), by contrast, resets the sort state to “no sort” on every call.
  2. Add a “Refresh” button to the toolbar

    Create a second button next to the status label and add it to the status bar.

    const refreshButton = document.createElement('button');
    refreshButton.type = 'button';
    refreshButton.textContent = 'Refresh';
    refreshButton.hidden = true; // hidden until the initial load succeeds
    controls.appendChild(refreshButton);

    What’s happening:

    • The button starts hidden so it does not appear during the initial loading phase.
    • setUiState() makes it visible only when the grid contains data and no error is active.
  3. Track four UI states

    The second example has one more status constant than the first — a “Refreshing…” state shown while a refresh is in progress.

    const STATUS_LOADING = 'Loading users...';
    const STATUS_READY = 'Users loaded. Sort a column, then click "Refresh" to see that the column sort order is preserved.';
    const STATUS_REFRESHING = 'Refreshing...';
    const STATUS_REFRESHED = 'Data refreshed -- column sort order was preserved.';
    const STATUS_ERROR = 'Failed to load users. Try again.';

    What’s happening:

    • STATUS_LOADING — shown during the first fetch.
    • STATUS_READY — shown after the first load; prompts the user to sort a column.
    • STATUS_REFRESHING — shown while a refresh request is in flight.
    • STATUS_REFRESHED — shown after a successful refresh; confirms that sort order was kept.
    • STATUS_ERROR — shown when any request fails.
  4. Update setUiState() to manage both buttons

    The helper controls the “Refresh” button alongside the existing “Retry” button.

    function setUiState({ loading = false, hasError = false, message = '' } = {}) {
    statusOutput.textContent = message;
    statusOutput.classList.toggle('is-error', hasError);
    retryButton.hidden = !hasError; // visible only on error
    refreshButton.hidden = hasError || loading; // visible only when data is ready
    refreshButton.disabled = loading;
    retryButton.disabled = loading;
    }

    What’s happening:

    • refreshButton.hidden = hasError || loading — the Refresh button appears only in the “ready” or “refreshed” state.
    • retryButton.hidden = !hasError — the Retry button appears only on error.
    • Both buttons are disabled while any request is in progress to prevent double-clicks.
  5. Extract fetchUsers() as a shared helper

    Both initialLoad() and refreshUsers() need to call the same endpoint. Extract the fetch logic into its own function so neither handler duplicates it.

    async function fetchUsers() {
    const response = await fetch('https://jsonplaceholder.typicode.com/users');
    if (!response.ok) {
    throw new Error(`Request failed with status: ${response.status}`);
    }
    return response.json();
    }

    What’s happening:

    • The function throws when the HTTP status is not 2xx, so callers can catch it in a unified catch block.
    • The mapUsersToGridRows() helper (unchanged from the first example) runs in each caller, keeping fetchUsers() focused on the network concern only.
  6. Use loadData() for the initial fetch

    On the first load there is no state to preserve, so loadData() is the right choice. It also performs a clean reset if the user retries after an error.

    async function initialLoad() {
    setUiState({ loading: true, message: STATUS_LOADING });
    try {
    const users = await fetchUsers();
    hot.loadData(mapUsersToGridRows(users));
    setUiState({ message: STATUS_READY });
    } catch (_error) {
    hot.loadData([]);
    setUiState({ hasError: true, message: STATUS_ERROR });
    }
    }

    What’s happening:

    1. Set the UI to the “Loading…” state and disable both buttons.
    2. Fetch users from the API.
    3. Call hot.loadData() — resets all states (sort order, selection) and renders the fresh data.
    4. On success, show STATUS_READY, which prompts the user to sort a column before refreshing.
    5. On error, clear the grid with hot.loadData([]) and show the Retry button.
  7. Use updateData() for subsequent refreshes

    When the user clicks Refresh, call hot.updateData() instead of hot.loadData(). The grid replaces its data while keeping the sort order exactly as the user left it.

    async function refreshUsers() {
    setUiState({ loading: true, message: STATUS_REFRESHING });
    try {
    const users = await fetchUsers();
    hot.updateData(mapUsersToGridRows(users));
    setUiState({ message: STATUS_REFRESHED });
    } catch (_error) {
    // On error, do not clear the grid -- the existing data is still valid.
    setUiState({ hasError: true, message: STATUS_ERROR });
    }
    }

    What’s happening:

    1. Set the UI to “Refreshing…” and hide the Refresh button.
    2. Fetch users from the API.
    3. Call hot.updateData() — replaces the data while keeping column sort order, selection, and column order intact.
    4. On success, show STATUS_REFRESHED and make the Refresh button available again.
    5. On error, show the Retry button. The grid keeps its current data because updateData() was never called — no data is lost.

    Key difference from loadData():

    • loadData() fires beforeLoadData / afterLoadData hooks and resets all registered state.
    • updateData() fires beforeUpdateData / afterUpdateData hooks and preserves all registered state.

Using dataProvider for automatic pagination and sorting

The first two examples manage the fetch lifecycle yourself: you call loadData() or updateData() at the right time and maintain loading state manually. Handsontable’s dataProvider option flips this model — you provide a fetchRows function and three CRUD callbacks, and the plugin drives everything else: initial load, pagination, column sorting, request cancellation, and loading overlays.

JavaScript
import { useCallback, useMemo, useRef } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
registerAllModules();
const pagination = { pageSize: 5 };
const ExampleComponent = () => {
const cachedRowsRef = useRef(null);
const statusRef = useRef(null);
const loadAllRows = useCallback(async (signal) => {
if (cachedRowsRef.current !== null) {
return cachedRowsRef.current;
}
const response = await fetch('https://jsonplaceholder.typicode.com/users', { signal });
if (!response.ok) {
throw new Error(`HTTP ${response.status}`);
}
const users = await response.json();
cachedRowsRef.current = users.map((u) => ({
id: u.id,
name: u.name,
username: u.username,
email: u.email,
city: u.address?.city ?? '',
company: u.company?.name ?? '',
}));
return cachedRowsRef.current;
}, []);
const fetchRows = useCallback(
async ({ page, pageSize, sort }, { signal }) => {
let rows = await loadAllRows(signal);
if (sort) {
rows = [...rows].sort((a, b) => {
const av = a[sort.prop];
const bv = b[sort.prop];
const cmp = av < bv ? -1 : av > bv ? 1 : 0;
return sort.order === 'asc' ? cmp : -cmp;
});
}
const start = (page - 1) * pageSize;
return {
rows: rows.slice(start, start + pageSize),
totalRows: rows.length,
};
},
[loadAllRows]
);
const dataProvider = useMemo(
() => ({
rowId: 'id',
fetchRows,
onRowsCreate: async () => {},
onRowsUpdate: async () => {},
onRowsRemove: async () => {},
}),
[fetchRows]
);
const beforeDataProviderFetch = useCallback((params) => {
if (params.skipLoading || !statusRef.current) return;
statusRef.current.textContent = 'Loading...';
statusRef.current.classList.remove('is-error');
}, []);
const afterDataProviderFetch = useCallback(() => {
if (!statusRef.current) return;
statusRef.current.textContent = 'Loaded from REST API via dataProvider.';
statusRef.current.classList.remove('is-error');
}, []);
const afterDataProviderFetchError = useCallback((error) => {
if (!statusRef.current) return;
statusRef.current.textContent = `Error: ${error.message}`;
statusRef.current.classList.add('is-error');
}, []);
return (
<div>
<div className="example-controls-container">
<output ref={statusRef} className="console">
Loading...
</output>
</div>
<HotTable
dataProvider={dataProvider}
colHeaders={['ID', 'Name', 'Username', 'Email', 'City', 'Company']}
columns={[
{ data: 'id', type: 'numeric', width: 70, readOnly: true },
{ data: 'name', type: 'text', width: 190, readOnly: true },
{ data: 'username', type: 'text', width: 150, readOnly: true },
{ data: 'email', type: 'text', width: 220, readOnly: true },
{ data: 'city', type: 'text', width: 140, readOnly: true },
{ data: 'company', type: 'text', width: 180, readOnly: true },
]}
pagination={pagination}
columnSorting={true}
emptyDataState={true}
rowHeaders={true}
height={360}
width="100%"
stretchH="all"
autoWrapRow={true}
beforeDataProviderFetch={beforeDataProviderFetch}
afterDataProviderFetch={afterDataProviderFetch}
afterDataProviderFetchError={afterDataProviderFetchError}
licenseKey="non-commercial-and-evaluation"
/>
</div>
);
};
export default ExampleComponent;
TypeScript
import { useCallback, useMemo, useRef } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
registerAllModules();
const pagination = { pageSize: 5 };
type ApiUser = {
id: number;
name: string;
username: string;
email: string;
address?: { city?: string };
company?: { name?: string };
};
type UserRow = {
id: number;
name: string;
username: string;
email: string;
city: string;
company: string;
};
type SortDescriptor = { prop: string; order: 'asc' | 'desc' } | null;
const ExampleComponent = () => {
const cachedRowsRef = useRef<UserRow[] | null>(null);
const statusRef = useRef<HTMLParagraphElement | null>(null);
const loadAllRows = useCallback(async (signal: AbortSignal): Promise<UserRow[]> => {
if (cachedRowsRef.current !== null) {
return cachedRowsRef.current;
}
const response = await fetch('https://jsonplaceholder.typicode.com/users', { signal });
if (!response.ok) {
throw new Error(`HTTP ${response.status}`);
}
const users = (await response.json()) as ApiUser[];
cachedRowsRef.current = users.map((u) => ({
id: u.id,
name: u.name,
username: u.username,
email: u.email,
city: u.address?.city ?? '',
company: u.company?.name ?? '',
}));
return cachedRowsRef.current;
}, []);
const fetchRows = useCallback(
async (
{ page, pageSize, sort }: { page: number; pageSize: number; sort: SortDescriptor },
{ signal }: { signal: AbortSignal }
) => {
let rows = await loadAllRows(signal);
if (sort) {
rows = [...rows].sort((a, b) => {
const av = a[sort.prop as keyof UserRow];
const bv = b[sort.prop as keyof UserRow];
const cmp = av < bv ? -1 : av > bv ? 1 : 0;
return sort.order === 'asc' ? cmp : -cmp;
});
}
const start = (page - 1) * pageSize;
return {
rows: rows.slice(start, start + pageSize),
totalRows: rows.length,
};
},
[loadAllRows]
);
const dataProvider = useMemo(
() => ({
rowId: 'id',
fetchRows,
onRowsCreate: async () => {},
onRowsUpdate: async () => {},
onRowsRemove: async () => {},
}),
[fetchRows]
);
const beforeDataProviderFetch = useCallback((params: { skipLoading?: boolean }) => {
if (params.skipLoading || !statusRef.current) return;
statusRef.current.textContent = 'Loading...';
statusRef.current.classList.remove('is-error');
}, []);
const afterDataProviderFetch = useCallback(() => {
if (!statusRef.current) return;
statusRef.current.textContent = 'Loaded from REST API via dataProvider.';
statusRef.current.classList.remove('is-error');
}, []);
const afterDataProviderFetchError = useCallback((error: Error) => {
if (!statusRef.current) return;
statusRef.current.textContent = `Error: ${error.message}`;
statusRef.current.classList.add('is-error');
}, []);
return (
<div>
<div className="example-controls-container">
<output ref={statusRef} className="console">
Loading...
</output>
</div>
<HotTable
dataProvider={dataProvider}
colHeaders={['ID', 'Name', 'Username', 'Email', 'City', 'Company']}
columns={[
{ data: 'id', type: 'numeric', width: 70, readOnly: true },
{ data: 'name', type: 'text', width: 190, readOnly: true },
{ data: 'username', type: 'text', width: 150, readOnly: true },
{ data: 'email', type: 'text', width: 220, readOnly: true },
{ data: 'city', type: 'text', width: 140, readOnly: true },
{ data: 'company', type: 'text', width: 180, readOnly: true },
]}
pagination={pagination}
columnSorting={true}
emptyDataState={true}
rowHeaders={true}
height={360}
width="100%"
stretchH="all"
autoWrapRow={true}
beforeDataProviderFetch={beforeDataProviderFetch}
afterDataProviderFetch={afterDataProviderFetch}
afterDataProviderFetchError={afterDataProviderFetchError}
licenseKey="non-commercial-and-evaluation"
/>
</div>
);
};
export default ExampleComponent;

What the third example covers

  • Configuring dataProvider with rowId, fetchRows, and CRUD callbacks.
  • Sorting rows in fetchRows from the sort query parameter before returning a page.
  • Slicing rows in fetchRows using the page and pageSize query parameters.
  • Enabling pagination, columnSorting, and emptyDataState so the plugin drives navigation and loading overlays.
  • Using beforeDataProviderFetch, afterDataProviderFetch, and afterDataProviderFetchError hooks for status feedback.
  • Passing an AbortSignal to fetch so superseded requests are cancelled automatically.

When to use each approach

ApproachWhen to use
loadData()One-shot load on page init; or when you want to reset all grid state (sort, selection) together with the data.
updateData()Periodic refresh where the user’s sort order, selection, and column layout must survive the data update.
dataProviderBackend-driven pagination, sorting, and filtering; CRUD that round-trips to a server; any dataset too large to keep in the browser.
  1. Cache the remote response

    The dataProvider plugin calls fetchRows every time the user changes page or clicks a sort header. If the API does not support server-side pagination or sorting (as with jsonplaceholder), fetch the full dataset once and reuse it.

    let cachedRows = null;
    async function loadAllRows(signal) {
    if (cachedRows !== null) {
    return cachedRows;
    }
    const response = await fetch('https://jsonplaceholder.typicode.com/users', { signal });
    if (!response.ok) {
    throw new Error(`HTTP ${response.status}`);
    }
    const users = await response.json();
    cachedRows = users.map((u) => ({
    id: u.id, name: u.name, username: u.username,
    email: u.email,
    city: u.address?.city ?? '',
    company: u.company?.name ?? '',
    }));
    return cachedRows;
    }

    What’s happening:

    • cachedRows starts as null. The first call hits the network; every later call returns the same array.
    • signal is the AbortSignal from fetchRows — passing it to fetch cancels the network request if the user sorts or changes pages before the current fetch finishes.
    • The raw API response is mapped to flat row objects that match your columns data keys.

    In production: Pass page, pageSize, sort, and filters directly to your API query string — no client-side caching needed. The client-side sort and slice shown in Steps 4 and 5 replace the server query.

  2. Replace the data array with a dataProvider object

    Instead of passing data: [] and calling hot.loadData(), pass a dataProvider object. Handsontable ignores any data array when the provider is complete.

    new Handsontable(gridContainer, {
    dataProvider: {
    rowId: 'id',
    fetchRows: ...,
    onRowsCreate: async () => {},
    onRowsUpdate: async () => {},
    onRowsRemove: async () => {},
    },
    // ...
    });

    What’s happening:

    • rowId: 'id' tells the plugin which property on each row object carries the stable row identity. It is required for the CRUD callbacks, refetch bookkeeping, and modifyRowHeader numbering across pages.
    • All five keys (rowId, fetchRows, onRowsCreate, onRowsUpdate, onRowsRemove) must be valid for the configuration to be complete. If any are missing, the plugin stays enabled but the affected operations no-op.
  3. Implement fetchRows

    fetchRows is the only required async function. It receives queryParameters and an options object that carries an AbortSignal.

    async fetchRows({ page, pageSize, sort }, { signal }) {
    const rows = await loadAllRows(signal);
    // ...
    return { rows: pagedSlice, totalRows: rows.length };
    }

    What’s happening:

    • page — 1-based page index driven by the Pagination plugin.
    • pageSize — rows per page; matches pagination: { pageSize: 5 } in grid options.
    • sort{ prop, order } object when a column header is sorted, or null when unsorted.
    • { signal } — AbortSignal from the plugin. Pass it to your fetch call so superseded requests are cancelled.
    • Return { rows, totalRows }. totalRows is the unsliced count — the Pagination plugin uses it to calculate the page count and navigation controls.
  4. Apply sort from query parameters

    When sort is non-null, sort a copy of the rows array before slicing. Never mutate the cached array.

    if (sort) {
    rows = [...rows].sort((a, b) => {
    const av = a[sort.prop];
    const bv = b[sort.prop];
    const cmp = av < bv ? -1 : av > bv ? 1 : 0;
    return sort.order === 'asc' ? cmp : -cmp;
    });
    }

    What’s happening:

    • sort.prop is the data key of the sorted column (for example 'name' or 'email').
    • sort.order is 'asc' or 'desc'.
    • The spread [...rows] prevents mutating the cached array. Sorting is referentially transparent — the cache always holds the original order.

    In production: You would not sort in the browser at all. Pass sort.prop and sort.order as query parameters to your API (?_sort=name&_order=asc for jsonplaceholder-style, or your own convention).

  5. Apply pagination from query parameters

    Slice the (sorted) array using page and pageSize.

    const start = (page - 1) * pageSize;
    return {
    rows: rows.slice(start, start + pageSize),
    totalRows: rows.length,
    };

    What’s happening:

    • page is 1-based, so page 1 starts at index 0, page 2 starts at index pageSize, and so on.
    • totalRows is the length of the full sorted array — not the slice. The Pagination plugin uses this to render the correct total page count.

    In production: Pass page and pageSize to your API (?_page=1&_limit=5 for jsonplaceholder) and return the server’s own total or count field as totalRows.

  6. Provide CRUD callbacks

    All three callbacks must be valid functions for the dataProvider configuration to be complete. For a read-only API, return resolved promises without calling the server.

    onRowsCreate: async () => {},
    onRowsUpdate: async () => {},
    onRowsRemove: async () => {},

    What’s happening:

    • The plugin serializes CRUD calls — a second mutation waits for the first to finish.
    • After each callback resolves, the plugin automatically refetches the current page.
    • These no-ops accept any user edit from the context menu but discard it on the next refetch. For a truly read-only grid, set readOnly: true on each column to prevent edits in the first place (as this example does).

    In production: Implement POST, PATCH, and DELETE calls here. See the Server-side data guide for payload shapes and the full CRUD lifecycle.

  7. Enable pagination, columnSorting, and emptyDataState

    pagination: { pageSize: 5 },
    columnSorting: true,
    emptyDataState: true,

    What’s happening:

    • pagination: { pageSize: 5 } enables the Pagination plugin and sets 5 rows per page. The plugin renders navigation controls below the grid and passes page and pageSize into every fetchRows call.
    • columnSorting: true enables server-driven single-column sorting. Clicking a header sets sort in the next fetchRows call. (multiColumnSorting is incompatible with dataProvider — use columnSorting only.)
    • emptyDataState: true renders a loading overlay while fetchRows is in flight and an “empty” state when the response contains zero rows.
  8. Use fetch hooks for status feedback

    beforeDataProviderFetch: ({ skipLoading }) => {
    if (!skipLoading) {
    statusOutput.textContent = 'Loading...';
    statusOutput.classList.remove('is-error');
    }
    },
    afterDataProviderFetch: () => {
    statusOutput.textContent = 'Loaded from REST API via dataProvider.';
    statusOutput.classList.remove('is-error');
    },
    afterDataProviderFetchError: (error) => {
    statusOutput.textContent = `Error: ${error.message}`;
    statusOutput.classList.add('is-error');
    },

    What’s happening:

    • beforeDataProviderFetch fires before every fetch. The skipLoading flag is true for internal refetches triggered after a sort or CRUD operation — skip updating the status label in those cases so the label does not flash “Loading…” on every column header click.
    • afterDataProviderFetch fires after a successful fetch. Update the status label to confirm data was loaded.
    • afterDataProviderFetchError fires when fetchRows rejects with a non-abort error. Update the status label with the error message. If you also set dialog: true in the grid options, the built-in Dialog plugin shows an error modal in addition to this hook.

What you learned

  • How to initialize Handsontable with data: [] and populate it after an async fetch with hot.loadData().
  • How hot.loadData() resets all grid state and hot.updateData() preserves column sort order, selection, and column order on refreshes.
  • How to use beforeDataProviderFetch, afterDataProviderFetch, and afterDataProviderFetchError hooks for status feedback during dataProvider fetches.
  • How the dataProvider architecture handles pagination, server-side sorting, and CRUD automatically — removing the need for manual data management.

Next steps